From 69ec460b6024c3deaa5616455ebd81d32abfeded Mon Sep 17 00:00:00 2001
From: Dave Page <dpage@pgadmin.org>
Date: Thu, 14 Mar 2019 16:52:42 +0000
Subject: [PATCH] Fix naming inconsistency for the column and FTS parser
 modules. Fixes #1269

---
 docs/en_US/release_notes_4_4.rst                              | 1 +
 .../fts_configurations/tests/test_fts_configuration_add.py    | 2 +-
 .../databases/schemas/{fts_parser => fts_parsers}/__init__.py | 0
 .../static/img/coll-fts_parser.svg                            | 0
 .../{fts_parser => fts_parsers}/static/img/fts_parser.svg     | 0
 .../{fts_parser => fts_parsers}/static/js/fts_parser.js       | 0
 .../templates/fts_parser/sql/default/create.sql               | 0
 .../templates/fts_parser/sql/default/delete.sql               | 0
 .../templates/fts_parser/sql/default/functions.sql            | 0
 .../templates/fts_parser/sql/default/nodes.sql                | 0
 .../templates/fts_parser/sql/default/properties.sql           | 0
 .../templates/fts_parser/sql/default/schema.sql               | 0
 .../templates/fts_parser/sql/default/sql.sql                  | 0
 .../templates/fts_parser/sql/default/update.sql               | 0
 .../schemas/{fts_parser => fts_parsers}/tests/__init__.py     | 0
 .../{fts_parser => fts_parsers}/tests/test_fts_parser_add.py  | 0
 .../tests/test_fts_parser_delete.py                           | 0
 .../tests/test_fts_parser_delete_multiple.py                  | 0
 .../{fts_parser => fts_parsers}/tests/test_fts_parser_get.py  | 0
 .../{fts_parser => fts_parsers}/tests/test_fts_parser_put.py  | 0
 .../schemas/{fts_parser => fts_parsers}/tests/utils.py        | 0
 .../databases/schemas/tables/{column => columns}/__init__.py  | 0
 .../tables/{column => columns}/static/img/coll-column.svg     | 0
 .../schemas/tables/{column => columns}/static/img/column.svg  | 0
 .../schemas/tables/{column => columns}/static/js/column.js    | 0
 .../templates/column/macros/privilege.macros                  | 0
 .../templates/column/macros/security.macros                   | 0
 .../schemas/tables/{column => columns}/tests/__init__.py      | 0
 .../tables/{column => columns}/tests/test_column_add.py       | 0
 .../tables/{column => columns}/tests/test_column_delete.py    | 0
 .../{column => columns}/tests/test_column_delete_multiple.py  | 0
 .../tables/{column => columns}/tests/test_column_get.py       | 0
 .../tables/{column => columns}/tests/test_column_msql.py      | 0
 .../tables/{column => columns}/tests/test_column_put.py       | 0
 .../schemas/tables/{column => columns}/tests/utils.py         | 0
 .../schemas/tables/indexes/tests/test_indexes_delete.py       | 2 +-
 .../tables/indexes/tests/test_indexes_delete_multiple.py      | 2 +-
 .../schemas/tables/indexes/tests/test_indexes_get.py          | 2 +-
 .../schemas/tables/indexes/tests/test_indexes_put.py          | 2 +-
 .../servers/databases/schemas/views/children/__init__.py      | 4 ++--
 40 files changed, 8 insertions(+), 7 deletions(-)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/__init__.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/static/img/coll-fts_parser.svg (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/static/img/fts_parser.svg (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/static/js/fts_parser.js (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/create.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/delete.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/functions.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/nodes.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/properties.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/schema.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/sql.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/templates/fts_parser/sql/default/update.sql (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/__init__.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/test_fts_parser_add.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/test_fts_parser_delete.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/test_fts_parser_delete_multiple.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/test_fts_parser_get.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/test_fts_parser_put.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/{fts_parser => fts_parsers}/tests/utils.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/__init__.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/static/img/coll-column.svg (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/static/img/column.svg (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/static/js/column.js (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/templates/column/macros/privilege.macros (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/templates/column/macros/security.macros (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/__init__.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/test_column_add.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/test_column_delete.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/test_column_delete_multiple.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/test_column_get.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/test_column_msql.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/test_column_put.py (100%)
 rename web/pgadmin/browser/server_groups/servers/databases/schemas/tables/{column => columns}/tests/utils.py (100%)

#diff --git a/docs/en_US/release_notes_4_4.rst b/docs/en_US/release_notes_4_4.rst
#index bcf903732..c40162973 100644
#--- a/docs/en_US/release_notes_4_4.rst
#+++ b/docs/en_US/release_notes_4_4.rst
#@@ -18,6 +18,7 @@ Features
# Bug fixes
# *********
# 
#+| `Bug #1269 <https://redmine.postgresql.org/issues/1269>`_ - Fix naming inconsistency for the column and FTS parser modules.
# | `Bug #3104 <https://redmine.postgresql.org/issues/3104>`_ - Improve a couple of German translations.
# | `Bug #3995 <https://redmine.postgresql.org/issues/3995>`_ - Avoid 'bogus varno' message from Postgres when viewing the SQL for a table with triggers.
# | `Bug #4019 <https://redmine.postgresql.org/issues/4019>`_ - Update all Python and JavaScript dependencies.
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_configurations/tests/test_fts_configuration_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_configurations/tests/test_fts_configuration_add.py
index 318f47c6a..e9bdf47f1 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_configurations/tests/test_fts_configuration_add.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_configurations/tests/test_fts_configuration_add.py
@@ -13,7 +13,7 @@
 import uuid
 
 from pgadmin.browser.server_groups.servers.databases.schemas. \
-    fts_parser.tests import utils as fts_parser_utils
+    fts_parsers.tests import utils as fts_parser_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tests import \
     utils as schema_utils
 from pgadmin.browser.server_groups.servers.databases.schemas \
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/__init__.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/__init__.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/__init__.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/static/img/coll-fts_parser.svg b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/static/img/coll-fts_parser.svg
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/static/img/coll-fts_parser.svg
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/static/img/coll-fts_parser.svg
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/static/img/fts_parser.svg b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/static/img/fts_parser.svg
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/static/img/fts_parser.svg
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/static/img/fts_parser.svg
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/static/js/fts_parser.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/static/js/fts_parser.js
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/static/js/fts_parser.js
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/static/js/fts_parser.js
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/create.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/create.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/create.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/create.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/delete.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/delete.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/delete.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/delete.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/functions.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/functions.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/functions.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/functions.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/nodes.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/nodes.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/nodes.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/nodes.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/properties.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/properties.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/properties.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/properties.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/schema.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/schema.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/schema.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/schema.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/sql.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/sql.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/sql.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/sql.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/update.sql b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/update.sql
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/templates/fts_parser/sql/default/update.sql
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/templates/fts_parser/sql/default/update.sql
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/__init__.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/__init__.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/__init__.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_add.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_add.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_add.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_delete.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_delete.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_delete.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_delete.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_delete_multiple.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_delete_multiple.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_delete_multiple.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_delete_multiple.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_get.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_get.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_get.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_get.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_put.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_put.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/test_fts_parser_put.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/test_fts_parser_put.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/utils.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parser/tests/utils.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/fts_parsers/tests/utils.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/__init__.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/__init__.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/__init__.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/static/img/coll-column.svg b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/img/coll-column.svg
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/static/img/coll-column.svg
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/img/coll-column.svg
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/static/img/column.svg b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/img/column.svg
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/static/img/column.svg
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/img/column.svg
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/static/js/column.js b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.js
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/static/js/column.js
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/static/js/column.js
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/templates/column/macros/privilege.macros b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/templates/column/macros/privilege.macros
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/templates/column/macros/privilege.macros
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/templates/column/macros/privilege.macros
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/templates/column/macros/security.macros b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/templates/column/macros/security.macros
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/templates/column/macros/security.macros
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/templates/column/macros/security.macros
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/__init__.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/__init__.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/__init__.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_add.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_add.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_add.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_add.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_delete.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_delete.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_delete.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_delete.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_delete_multiple.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_delete_multiple.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_delete_multiple.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_delete_multiple.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_get.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_get.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_get.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_get.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_msql.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_msql.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_msql.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_msql.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_put.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_put.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/test_column_put.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/test_column_put.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/utils.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/utils.py
similarity index 100%
rename from web/pgadmin/browser/server_groups/servers/databases/schemas/tables/column/tests/utils.py
rename to web/pgadmin/browser/server_groups/servers/databases/schemas/tables/columns/tests/utils.py
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete.py
index 0ae51cd3e..35652a7ef 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete.py
@@ -9,7 +9,7 @@
 
 import uuid
 
-from pgadmin.browser.server_groups.servers.databases.schemas.tables.column. \
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.columns. \
     tests import utils as columns_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete_multiple.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete_multiple.py
index 2f7facc14..22e6f9f87 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete_multiple.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_delete_multiple.py
@@ -10,7 +10,7 @@
 import uuid
 import json
 
-from pgadmin.browser.server_groups.servers.databases.schemas.tables.column. \
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.columns. \
     tests import utils as columns_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_get.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_get.py
index fc6db349e..b03647283 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_get.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_get.py
@@ -9,7 +9,7 @@
 
 import uuid
 
-from pgadmin.browser.server_groups.servers.databases.schemas.tables.column. \
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.columns. \
     tests import utils as columns_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_put.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_put.py
index 547413855..5fdaea24d 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_put.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/tables/indexes/tests/test_indexes_put.py
@@ -10,7 +10,7 @@
 import json
 import uuid
 
-from pgadmin.browser.server_groups.servers.databases.schemas.tables.column. \
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.columns. \
     tests import utils as columns_utils
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.tests \
     import utils as tables_utils
diff --git a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/children/__init__.py b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/children/__init__.py
index 0b5500a34..b99b96a56 100644
--- a/web/pgadmin/browser/server_groups/servers/databases/schemas/views/children/__init__.py
+++ b/web/pgadmin/browser/server_groups/servers/databases/schemas/views/children/__init__.py
@@ -1,11 +1,11 @@
 """
-We will use the exisiting modules for creating children module under
+We will use the existing modules for creating children module under
 materialize views.
 
 Do not remove these imports as they will be automatically imported by the view
 module as its children
 """
-from pgadmin.browser.server_groups.servers.databases.schemas.tables.column \
+from pgadmin.browser.server_groups.servers.databases.schemas.tables.columns \
     import blueprint as columns_module
 from pgadmin.browser.server_groups.servers.databases.schemas.tables.indexes \
     import blueprint as indexes_modules